<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="编号" prop="fNo">
        <el-input
          v-model="queryParams.fNo"
          placeholder="请输入编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="名称" prop="fName">
        <el-input
          v-model="queryParams.fName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="地址" prop="fAddr">
        <el-input
          v-model="queryParams.fAddr"
          placeholder="请输入地址"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="fStatus">
        <!--<el-select v-model="queryParams.fStatus" placeholder="请选择状态" clearable size="small">
          <el-option label="请选择字典生成" value="" />
        </el-select>-->
        <el-select
          v-model="queryParams.fStatus"
          placeholder="请选择状态"
          clearable
          size="small"
          style="width: 240px"
        >
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['basicdata:warehouse:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['basicdata:warehouse:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['basicdata:warehouse:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['basicdata:warehouse:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="warehouseList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" label="序号" align="center"/>
      <el-table-column label="编号" align="center" prop="fNo" />
      <el-table-column label="名称" align="center" prop="fName" />
      <el-table-column label="地址" align="center" prop="fAddr" />
      <el-table-column label="状态" align="center">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.fStatus"
            active-value="0"
            inactive-value="1"
            @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['basicdata:warehouse:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['basicdata:warehouse:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改仓库对话框 -->
    <el-dialog :title="title" :visible.sync="open" :close-on-click-modal="false" width="80%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="8">
            <el-form-item label="编号" prop="fNo">
              <el-input v-model="form.fNo"  v-on:keyup="testFno" placeholder="请输入编号" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="名称" prop="fName">
              <el-input v-model="form.fName" placeholder="请输入名称" />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="地址" prop="fAddr">
              <el-input v-model="form.fAddr" placeholder="请输入地址" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item label="状态">
              <el-radio-group v-model="form.fStatus">
                <el-radio
                  v-for="dict in statusOptions"
                  :key="dict.dictValue"
                  :label="dict.dictValue"
                >{{dict.dictLabel}}</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="库容" prop="fTotalgross">
              <el-input v-model="form.fTotalgross" placeholder="请输入库容" />
            </el-form-item>
          </el-col>
        </el-row>

        <!--<el-form-item label="状态，默认 T ,正常T 停用F 下拉选择">
          <el-radio-group v-model="form.fStatus">
            <el-radio label="1">请选择字典生成</el-radio>
          </el-radio-group>
        </el-form-item>-->
        <!--<el-form-item label="删除状态" prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除状态" />
        </el-form-item>-->
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>

        <div >
          <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
              <el-button
                type="primary"
                icon="el-icon-plus"
                size="mini"
                @click="addRow(contactList)"
              >添加</el-button>
            </el-col>
          </el-row>
        </div>

        <el-table v-loading="loading" :data="contactList" @selection-change="handleSelectionChange">

          <el-table-column type="index" label="序号" align="center"/>

          <el-table-column label="库区编号" align="center" prop="fNo" >
            <template scope="scope">
              <el-input v-model="scope.row.fNo"  placeholder="库区编号" />
            </template>
          </el-table-column>

          <el-table-column label="库区名称" align="center" prop="fName" >
            <template scope="scope">
              <el-input v-model="scope.row.fName"  placeholder="库区名称" />
            </template>
          </el-table-column>

          <el-table-column label="库区地址" align="center" prop="fAddr" >
            <template scope="scope">
              <el-input v-model="scope.row.fAddr"  placeholder="库区地址" />
            </template>
          </el-table-column>

          <el-table-column label="备注" align="center" prop="remark" >
            <template scope="scope">
              <el-input v-model="scope.row.remark"  placeholder="备注" />
            </template>
          </el-table-column>

          <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="100">
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click.native.prevent="deleteRow(scope.$index,scope.row.fId, contactList)"
                v-hasPermi="['basicdata:contact:edit']"
              >删除</el-button>
            </template>
          </el-table-column>
        </el-table>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listWarehouse, getWarehouse, delWarehouse, addWarehouse, updateWarehouse,changeWareStatus, exportWarehouse,delCusCon } from "../../../api/basicdata/warehouse";

export default {
  name: "Warehouse",
  components: {
  },
  data() {
    return {
      // 从表
      contactList:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 仓库表格数据
      warehouseList: [],
      // 状态数据字典
      statusOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fNo: null,
        fName: null,
        fAddr: null,
        fStatus: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fNo: [
          { required: true, message: "编号不能为空", trigger: "blur" }
        ],
        fName: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
        fAddr: [
          { required: true, message: "地址不能为空", trigger: "blur" }
        ],
        fTotalgross: [
          { required: true, message: "库容不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_normal_disable").then(response => {
      this.statusOptions = response.data;
    });
  },
  methods: {
    // 添加行
    addRow(tableData){
      var obj = {}
      tableData.push(obj)
    },
    //删除行
    deleteRow(index1,index, rows) {
      if(index!=null && index!=''){
        this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCusCon(index);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      } else {
        rows.splice(index1, 1)
      }
    },
    /** 查询仓库列表 */
    getList() {
      this.loading = true;
      listWarehouse(this.queryParams).then(response => {
        this.warehouseList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 检验唯一
    testFno(){
       alert(1);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
      this.contList();
    },
    // 表单重置
    reset() {
      this.form = {
        fId: null,
        fNo: null,
        fName: null,
        fAddr: null,
        fStatus: "0",
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    // 从表重置
    contList() {
      this.contactList = []
    },
    // 状态修改
    handleStatusChange(row) {
      let text = row.fStatus === "0" ? "启用" : "停用";
      this.$confirm('确认要"' + text + '""' + row.fName + '"吗?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return changeWareStatus(row.fId, row.fStatus);
      }).then(() => {
        this.msgSuccess(text + "成功");
      }).catch(function() {
        row.fStatus = row.fStatus === "0" ? "1" : "0";
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.contList();
      this.open = true;
      this.title = "添加仓库";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fId = row.fId || this.ids
      getWarehouse(fId).then(response => {
        this.form = response.data['tWarehouse'];
        this.contactList= response.data['tWarehouseArea'];
        this.open = true;
        this.title = "修改仓库";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (this.contactList.length === 0) {
          this.msgError("库区为空");
          return
        }
        if (valid) {
          if (this.form.fId != null) {
            let formDate= new FormData()
            formDate.append('tWarehouse',JSON.stringify(this.form));
            formDate.append('tWarehouseArea',JSON.stringify(this.contactList));
            addWarehouse(formDate).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            let formDate= new FormData()
            formDate.append('tWarehouse',JSON.stringify(this.form));
            formDate.append('tWarehouseArea',JSON.stringify(this.contactList));
            addWarehouse(formDate).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fIds = row.fId || this.ids;
      this.$confirm('是否确认删除仓库编号为"' + fIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delWarehouse(fIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有仓库数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportWarehouse(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    }
  }
};
</script>
